<?php

/**
 * @author Jasman
 * @copyright Ihsana IT Solution 2020
 * @package WP-Dev Tools
 * @license Commercial License
 **/

$module['name'] = 'html-input-color';
$module['label'] = 'HTML ~ Input: Color';

$module['options']['value'] = '#000000';
$module['options']['placeholder'] = '#eeeeee';
$module['options']['help'] = '<strong>format</strong>: hex color code, eg: <code>#000000</code>';
$module['options']['type'] = 'color';

$module['default']['value'] = '#000000';
$module['default']['placeholder'] = '#eeeeee';
$module['default']['help'] = '<strong>format</strong>: hex color code, eg: <code>#000000</code>';
$module['default']['type'] = 'color';

$module['info']['value'] = 'Please enter the hex color code';
$module['info']['placeholder'] = 'Please enter the hex color code';

$module['render_content'] = null;
$module['render_content'] .= "\t\t" . '$current_data = get_post_meta($post->ID, "_{{VAR}}", true);' . "\r\n";
$module['render_content'] .= "\t\t" . 'if($current_data == ""){' . "\r\n";
$module['render_content'] .= "\t\t\t" . '$current_data = "{{DEFAULT}}";' . "\r\n";
$module['render_content'] .= "\t\t" . '}' . "\r\n";
$module['render_content'] .= "\t\t" . '?>' . "\r\n";
$module['render_content'] .= "\t\t" . '<tr>' . "\r\n";
$module['render_content'] .= "\t\t\t" . '<th scope="row">' . "\r\n";
$module['render_content'] .= "\t\t\t\t" . '<label for="{{ID}}"><?php _e("{{LABEL}}", "{{TEXT-DOMAIN}}"); ?></label>' . "\r\n";
$module['render_content'] .= "\t\t\t" . '</th>' . "\r\n";
$module['render_content'] .= "\t\t\t" . '<td>' . "\r\n";
$module['render_content'] .= "\t\t\t" . '<input class="regular-text {{SHORTNAME}}-from-control" type="color" id="{{ID}}" name="{{NAME}}" value="<?php echo esc_attr($current_data); ?>" placeholder="{{OPTIONS}}" />' . "\r\n";
$module['render_content'] .= "\t\t\t" . '<p class="description"><?php _e("{{INFO}}", "{{TEXT-DOMAIN}}"); ?></p>' . "\r\n";
$module['render_content'] .= "\t\t\t" . '</td>' . "\r\n";
$module['render_content'] .= "\t\t" . '</tr>' . "\r\n";
$module['render_content'] .= "\t\t" . '<?php' . "\r\n";

$module['save_post'] = null;
$module['save_post'] .= "\t\t" . '$data = sanitize_text_field($_POST["{{NAME}}"]);' . "\r\n";
$module['save_post'] .= "\t\t" . 'update_post_meta($post_id, "_{{VAR}}", $data);' . "\r\n";


$module['admin_footer'] = null;
$module['admin_enqueue_scripts'] = null;

$color = array();
$color[] = '#000000';
$color[] = '#993300';
$color[] = '#003300';
$color[] = '#00CCFF';
$color[] = '#993366';
$color[] = '#FF99CC';
$color[] = '#99CCFF';
$color[] = '#800080';

$module['dummy'] = null;
$module['dummy'] = $color[rand(0, (count($color) - 1))];

?>