<?php

/**
 * @author Jasman
 * @copyright Ihsana IT Solution 2020
 * @package WP-Dev Tools
 * @license Commercial License
 **/

$db = new DB();
$string = new StringConvert();
$project = $db->getProject();


$module['name'] = 'wp-dropdown-pages';
$module['label'] = 'WordPress ~ Dropdown Pages (Hierarchical)';

$module['options']['value'] = 'page';
$module['options']['placeholder'] = 'page';
$module['options']['help'] = 'choose pages that support hierarchical';

$module['default']['value'] = '';
$module['default']['placeholder'] = 'page';

$module['info']['value'] = '';
$module['info']['placeholder'] = '';

$current_page = null;
if (isset($__field['options']))
{
    if ($__field['options'] != '')
    {
        $current_page = $__field['options'];
    }
}

$module['render_content'] = null;
$module['render_content'] .= "\t\t" . '$current_data = get_post_meta($post->ID, "_{{VAR}}", true);' . "\r\n";
$module['render_content'] .= "\t\t" . 'if($current_data == ""){' . "\r\n";
$module['render_content'] .= "\t\t\t" . '$current_data = "{{DEFAULT}}";' . "\r\n";
$module['render_content'] .= "\t\t" . '}' . "\r\n";
$module['render_content'] .= "\t\t" . '$args = array(' . "\r\n";
$module['render_content'] .= "\t\t\t" . '"post_type" => "' . $current_page . '",' . "\r\n";
$module['render_content'] .= "\t\t\t" . '"echo" => true,' . "\r\n";
$module['render_content'] .= "\t\t\t" . '"id" => "{{ID}}",' . "\r\n";
$module['render_content'] .= "\t\t\t" . '"name" => "{{NAME}}",' . "\r\n";
$module['render_content'] .= "\t\t\t" . '"class" => "regular-text {{SHORTNAME}}-from-control",' . "\r\n";
$module['render_content'] .= "\t\t\t" . '"selected" => $current_data,' . "\r\n";
$module['render_content'] .= "\t\t" . ');' . "\r\n";
$module['render_content'] .= "\t\t" . '?>' . "\r\n";
$module['render_content'] .= "\t\t" . '<tr>' . "\r\n";
$module['render_content'] .= "\t\t\t" . '<th scope="row">' . "\r\n";
$module['render_content'] .= "\t\t\t\t" . '<label for="{{ID}}"><?php _e("{{LABEL}}", "{{TEXT-DOMAIN}}"); ?></label>' . "\r\n";
$module['render_content'] .= "\t\t\t" . '</th>' . "\r\n";
$module['render_content'] .= "\t\t\t" . '<td>' . "\r\n";
$module['render_content'] .= "\t\t\t" . '<?php wp_dropdown_pages($args); ?>' . "\r\n";
$module['render_content'] .= "\t\t\t" . '<p class="description"><?php _e("{{INFO}}", "{{TEXT-DOMAIN}}"); ?></p>' . "\r\n";
$module['render_content'] .= "\t\t\t" . '</td>' . "\r\n";
$module['render_content'] .= "\t\t" . '</tr>' . "\r\n";
$module['render_content'] .= "\t\t" . '<?php' . "\r\n";

$module['save_post'] = null;
$module['save_post'] .= "\t\t" . '$data = sanitize_text_field($_POST["{{NAME}}"]);' . "\r\n";
$module['save_post'] .= "\t\t" . 'update_post_meta($post_id, "_{{VAR}}", $data);' . "\r\n";


$module['admin_footer'] = null;
$module['admin_enqueue_scripts'] = null;

$__pages = array();
foreach ($db->getCustomPosts() as $posts)
{
    if ($posts['hierarchical'] == true)
    {
        $__pages[] = array('value' => $string->toVar($project['short-name'] . '_' . $posts['name']), 'label' => $string->toVar($project['short-name'] . '_' . $posts['name']) . ' (Custom Posts)');
    }
}

$module['code']['js'] = null;
$module['code']['js'] .= "\t\t\t\t\t" . '' . "\r\n";
$module['code']['js'] .= "\t\t\t\t\t" . '$("#meta-box-options-" + item_target).addClass("hidden");' . "\r\n";
$module['code']['js'] .= "\t\t\t\t\t" . '' . "\r\n";
$module['code']['js'] .= "\t\t\t\t\t" . 'var options = ' . json_encode($__pages) . ';' . "\r\n";
$module['code']['js'] .= "\t\t\t\t\t" . 'var select_custom_pages ="";' . "\r\n";
$module['code']['js'] .= "\t\t\t\t\t" . 'select_custom_pages += "<select onclick=\"setField(\'#meta-box-options-" + item_target + "\',this.value)\" id=\"#meta-box-options-select-option-" + item_target + "\" class=\"form-control\">"; ' . "\r\n";
$module['code']['js'] .= "\t\t\t\t\t" . 'select_custom_pages += "<option value=\"page\">page (WP Core)</option>"; ' . "\r\n";
$module['code']['js'] .= "\t\t\t\t\t" . '$.each(options, function(i, item) {' . "\r\n";
$module['code']['js'] .= "\t\t\t\t\t\t" . 'var selected = "";' . "\r\n";
$module['code']['js'] .= "\t\t\t\t\t\t" . 'if(meta_box_options[item_target] == item.value ){' . "\r\n";
$module['code']['js'] .= "\t\t\t\t\t\t" . 'selected = "selected";' . "\r\n";
$module['code']['js'] .= "\t\t\t\t\t\t" . '}' . "\r\n";
$module['code']['js'] .= "\t\t\t\t\t\t" . 'select_custom_pages += "<option " + selected + " value=\"" + item.value +  "\">" + item.label +  "</option>"; ' . "\r\n";
$module['code']['js'] .= "\t\t\t\t\t" . '});' . "\r\n";
$module['code']['js'] .= "\t\t\t\t\t" . 'select_custom_pages += "</select>"; ' . "\r\n";
$module['code']['js'] .= "\t\t\t\t\t" . '' . "\r\n";
$module['code']['js'] .= "\t\t\t\t\t" . '$("#meta-box-options-select-" + item_target).html(select_custom_pages);' . "\r\n";
$module['code']['js'] .= "\t\t\t\t\t" . '$("#meta-box-options-" + item_target).val(meta_box_options[item_target]);' . "\r\n";

?>