<?php

/**
 * @author Jasman
 * @copyright Ihsana IT Solution 2020
 * @package WP-Dev Tools
 * @license Commercial License
 */


class Modules
{
    var $textdomain = 'text-domain';
    var $short_name = 'myapp';
    var $project = array();
    var $string = null;
    function __construct($project)
    {
        $this->string = new StringConvert();

        $this->project = $project;
        $this->textdomain = $this->project['project']['prefix'];
        $this->short_name = $this->project['project']['short-name'];
    }

    /**
     * Modules::ExtraFields()
     * 
     * @param mixed $__field
     * @param string $type
     * @return void
     */
    function ExtraFields($taxonomy = '', $__field = array(), $funcType = '')
    {
        $module_path = IHS_MODULE_DIR . '\extra-fields\*.mod.php';
        $options = $modules = $module = array();
        foreach (glob($module_path) as $filename)
        {
            $module = null;
            include ($filename);
            $var = md5($module['name']);
            $modules[$var] = $module;
        }
        $ret = null;

        //periksa nama dan type sama
        $module = null;
        foreach ($modules as $module)
        {
            if ($module['name'] == $__field['type'])
            {
                switch ($funcType)
                {
                    case 'edit_form_fields':
                        $ret .= $this->fixExtraFields($taxonomy, $__field, $module['edit_form_fields']);
                        break;
                    case 'edit_form':
                        $ret .= $this->fixExtraFields($taxonomy, $__field, $module['edit_form']);
                        break;
                    case 'add_form_fields':
                        $ret .= $this->fixExtraFields($taxonomy, $__field, $module['add_form_fields']);
                        break;
                    case 'add_form':
                        $ret .= $this->fixExtraFields($taxonomy, $__field, $module['add_form']);
                        break;
                    case 'admin_footer':
                        if (isset($module['admin_footer']))
                        {
                            $ret .= $this->fixExtraFields($taxonomy, $__field, $module['admin_footer']);
                        }
                        break;
                    case 'admin_enqueue_scripts':
                        if (isset($module['admin_enqueue_scripts']))
                        {
                            $ret .= $this->fixExtraFields($taxonomy, $__field, $module['admin_enqueue_scripts']);
                        }
                        break;
                }
            }
        }
        return $ret;
    }

    /**
     * Modules::fixExtraFields()
     * 
     * @param mixed $taxonomy
     * @param mixed $field
     * @param mixed $string
     * @return
     */
    private function fixExtraFields($taxonomy, $field, $string)
    {
        $new_string = $string;
        $new_string = str_replace('{{NAME}}', $this->string->toFileName($taxonomy . '-' . $field['name']), $new_string);
        $new_string = str_replace('{{ID}}', $this->string->toFileName($taxonomy . '-' . $field['name']), $new_string);
        $new_string = str_replace('{{LABEL}}', $field['label'], $new_string);
        $new_string = str_replace('{{OPTIONS}}', $field['options'], $new_string);
        $new_string = str_replace('{{INFO}}', $field['info'], $new_string);
        $new_string = str_replace('{{TEXT-DOMAIN}}', $this->textdomain, $new_string);
        $new_string = str_replace('{{TEXTDOMAIN}}', $this->textdomain, $new_string);
        $new_string = str_replace('{{PLACEHOLDER}}', $field['options'], $new_string);
        $new_string = str_replace('{{DEFAULT}}', $field['default'], $new_string);
        $new_string = str_replace('{{SHORT-NAME}}', $this->short_name, $new_string);
        $new_string = str_replace('{{SHORTNAME}}', strtolower($this->short_name), $new_string);

        return $new_string;
    }


    /**
     * Modules::ShortCodes()
     * 
     * @param mixed $__field
     * @param string $type
     * @return void
     */
    function ShortCode($__field = array(), $funcType = '')
    {
        $module_path = IHS_MODULE_DIR . '\short-codes\attributes\*.mod.php';
        $options = $modules = $module = array();
        foreach (glob($module_path) as $filename)
        {
            $module = null;
            include ($filename);
            $var = md5($module['name']);
            $modules[$var] = $module;
        }
        $ret = null;

        //periksa nama dan type sama
        $module = null;
        foreach ($modules as $module)
        {
            if ($module['name'] == $__field['type'])
            {
                switch ($funcType)
                {
                    case 'tinymce':
                        $ret .= $this->fixShortCode($__field, $module['tinymce']);
                        break;
                }
            }
        }
        return $ret;
    }

    /**
     * Modules::ShortCodeFrontEnd()
     * 
     * @param mixed $__field
     * @param string $type
     * @return void
     */
    function ShortCodeFrontEnd($__field = array(), $funcType = '')
    {
        $module_path = IHS_MODULE_DIR . '\short-codes\front-ends\*.mod.php';
        $options = $modules = $module = array();
        foreach (glob($module_path) as $filename)
        {
            $module = null;
            include ($filename);
            $var = md5($module['name']);
            $modules[$var] = $module;
        }
        $ret = null;

        //periksa nama dan type sama
        $module = null;
        foreach ($modules as $module)
        {
            if ($module['name'] == $__field['type'])
            {
                switch ($funcType)
                {
                    case 'shortcode':
                        $ret .= $this->fixShortCodeFrontEnd($__field, $module['shortcode']);
                        break;
                }
            }
        }
        return $ret;
    }

    /**
     * Modules::fixShortCode()
     * 
     * @param mixed $field
     * @param mixed $string
     * @return
     */
    private function fixShortCode($field, $string)
    {
        $new_string = $string;
        $new_string = str_replace('{{NAME}}', $this->string->toFileName($this->short_name . '-' . $field['name']), $new_string);
        $new_string = str_replace('{{ID}}', $this->string->toFileName($this->short_name . '-' . $field['name']), $new_string);
        $new_string = str_replace('{{VAR}}', $this->string->toVar($field['name']), $new_string);
        $new_string = str_replace('{{LABEL}}', $field['label'], $new_string);
        $new_string = str_replace('{{OPTIONS}}', $field['options'], $new_string);
        $new_string = str_replace('{{INFO}}', $field['info'], $new_string);
        $new_string = str_replace('{{TEXT-DOMAIN}}', $this->textdomain, $new_string);
        $new_string = str_replace('{{TEXTDOMAIN}}', $this->textdomain, $new_string);
        $new_string = str_replace('{{PLACEHOLDER}}', $field['options'], $new_string);
        $new_string = str_replace('{{DEFAULT}}', $field['default'], $new_string);
        $new_string = str_replace('{{SHORT-NAME}}', $this->short_name, $new_string);
        $new_string = str_replace('{{SHORTNAME}}', strtolower($this->short_name), $new_string);

        return $new_string;
    }

    /**
     * Modules::fixShortCodeFrontEnd()
     * 
     * @param mixed $field
     * @param mixed $string
     * @return
     */
    private function fixShortCodeFrontEnd($field, $string)
    {
        $new_string = $string;
        $new_string = str_replace('{{NAME}}', $this->string->toFileName($this->short_name . '-' . $field['name']), $new_string);
        $new_string = str_replace('{{ID}}', $this->string->toFileName($this->short_name . '-' . $field['name']), $new_string);
        $new_string = str_replace('{{VAR}}', $this->string->toVar($field['name']), $new_string);
        $new_string = str_replace('{{LABEL}}', $field['label'], $new_string);
        $new_string = str_replace('{{OPTION}}', $field['option'], $new_string);
        $new_string = str_replace('{{TEXT-DOMAIN}}', $this->textdomain, $new_string);
        $new_string = str_replace('{{TEXTDOMAIN}}', $this->textdomain, $new_string);
        $new_string = str_replace('{{PLACEHOLDER}}', $field['option'], $new_string);
        $new_string = str_replace('{{SHORT-NAME}}', $this->short_name, $new_string);
        $new_string = str_replace('{{SHORTNAME}}', strtolower($this->short_name), $new_string);

        return $new_string;
    }


    /**
     * Modules::CustomFields()
     * 
     * @param mixed $__field
     * @param string $funcType
     * @return
     */
    function CustomFields($__field = array(), $funcType = '')
    {
        $module_path = IHS_MODULE_DIR . '\custom-fields\*.mod.php';
        $options = $modules = $module = array();
        foreach (glob($module_path) as $filename)
        {
            $module = null;
            include ($filename);
            $var = md5($module['name']);
            $modules[$var] = $module;
        }
        $ret = null;

        //periksa nama dan type sama
        $module = null;
        foreach ($modules as $module)
        {
            if ($module['name'] == $__field['type'])
            {

                switch ($funcType)
                {
                    case 'render_content':
                        $ret .= $this->fixCustomFields($__field, $module['render_content']);
                        break;
                    case 'save_post':
                        $ret .= $this->fixCustomFields($__field, $module['save_post']);
                        break;
                    case 'admin_footer':
                        if (isset($module['admin_footer']))
                        {
                            $ret .= $this->fixCustomFields($__field, $module['admin_footer']);
                        }

                        break;
                    case 'admin_enqueue_scripts':
                        if (isset($module['admin_enqueue_scripts']))
                        {
                            $ret .= $this->fixCustomFields($__field, $module['admin_enqueue_scripts']);
                        }
                        break;
                    case 'dummy':
                        if (isset($module['dummy']))
                        {
                            $ret .= $this->fixCustomFields($__field, $module['dummy']);
                        }
                        break;
                }
            }
        }
        return $ret;
    }
    /**
     * Modules::fixCustomFields()
     * 
     * @param mixed $field
     * @param mixed $string
     * @return void
     */
    private function fixCustomFields($field, $string)
    {
        $new_string = $string;
        $new_string = str_replace('{{NAME}}', $this->string->toFileName($this->short_name . '-' . $field['name']), $new_string);
        $new_string = str_replace('{{ID}}', $this->string->toFileName($this->short_name . '-' . $field['name']), $new_string);
        $new_string = str_replace('{{VAR}}', $this->string->toVar($this->short_name . '-' . $field['name']), $new_string);
        $new_string = str_replace('{{LABEL}}', $field['label'], $new_string);
        $new_string = str_replace('{{OPTIONS}}', $field['options'], $new_string);
        $new_string = str_replace('{{INFO}}', $field['info'], $new_string);
        $new_string = str_replace('{{TEXT-DOMAIN}}', $this->textdomain, $new_string);
        $new_string = str_replace('{{TEXTDOMAIN}}', $this->textdomain, $new_string);
        $new_string = str_replace('{{PLACEHOLDER}}', $field['options'], $new_string);
        $new_string = str_replace('{{DEFAULT}}', $field['default'], $new_string);
        $new_string = str_replace('{{SHORT-NAME}}', $this->short_name, $new_string);
        $new_string = str_replace('{{SHORTNAME}}', strtolower($this->short_name), $new_string);
        return $new_string;
    }

    /**
     * Modules::WidgetFrontEnd()
     * 
     * @param mixed $__field
     * @param string $funcType
     * @return
     */
    function WidgetFrontEnd($__field = array(), $funcType = '')
    {
        $ret = null;


        $module_path = IHS_MODULE_DIR . '\widgets\front-ends\*.mod.php';
        $modules = $module = array();
        foreach (glob($module_path) as $filename)
        {
            $module = null;
            include ($filename);
            $var = md5($module['name']);
            $modules[$var] = $module;
        }

        //periksa nama dan type sama
        $module = null;
        foreach ($modules as $module)
        {


            if ($module['name'] == $__field['type'])
            {

                switch ($funcType)
                {
                    case 'widget':
                        if (isset($module['widget']))
                        {

                            $ret .= $this->fixWidgetFrontEnd($__field, $module['widget']);
                        }
                        break;
                }
            }
        }
        return $ret;
    }


    /**
     * Modules::fixWidgetFrontEnd()
     * 
     * @param mixed $field
     * @param mixed $string
     * @return void
     */
    private function fixWidgetFrontEnd($field, $string)
    {
        $new_string = $string;
        $new_string = str_replace('{{OPTION}}', $field['option'], $new_string);
        $new_string = str_replace('{{LABEL}}', $field['label'], $new_string);
        $new_string = str_replace('{{SHORT-NAME}}', $this->short_name, $new_string);
        $new_string = str_replace('{{SHORTNAME}}', strtolower($this->short_name), $new_string);
        $new_string = str_replace('{{TEXT-DOMAIN}}', $this->textdomain, $new_string);
        $new_string = str_replace('{{TEXTDOMAIN}}', $this->textdomain, $new_string);
        return $new_string;
    }


    /**
     * Modules::WidgetOption()
     * 
     * @param mixed $__field
     * @param string $funcType
     * @return
     */
    function WidgetOption($__field = array(), $funcType = '')
    {
        $module_path = IHS_MODULE_DIR . '\widgets\options\*.mod.php';
        $options = $modules = $module = array();
        foreach (glob($module_path) as $filename)
        {
            $module = null;
            include ($filename);
            $var = md5($module['name']);
            $modules[$var] = $module;
        }
        $ret = null;

        //periksa nama dan type sama
        $module = null;
        foreach ($modules as $module)
        {
            if ($module['name'] == $__field['type'])
            {
                switch ($funcType)
                {
                    case 'form':
                        $ret .= $this->fixWidgetOptions($__field, $module['form']);
                        break;
                    case 'update':
                        $ret .= $this->fixWidgetOptions($__field, $module['update']);
                        break;
                    case 'admin_footer':
                        if (isset($module['admin_footer']))
                        {
                            $ret .= $this->fixWidgetOptions($__field, $module['admin_footer']);
                        }
                        break;
                    case 'admin_enqueue_scripts':
                        if (isset($module['admin_enqueue_scripts']))
                        {
                            $ret .= $this->fixWidgetOptions($__field, $module['admin_enqueue_scripts']);
                        }
                        break;
                }
            }
        }
        return $ret;
    }


    /**
     * Modules::PluginOptions()
     * 
     * @param string $callback
     * @param mixed $__field
     * @param string $type
     * @return void
     */
    function PluginOptions($setting, $page = '', $section = '', $callback = '', $__field = array(), $funcType = '')
    {
        $module_path = IHS_MODULE_DIR . '\plugin-options\*.mod.php';
        $options = $modules = $module = array();
        foreach (glob($module_path) as $filename)
        {
            $module = null;
            include ($filename);
            $var = md5($module['name']);
            $modules[$var] = $module;
        }
        $ret = null;

        //periksa nama dan type sama
        $module = null;
        foreach ($modules as $module)
        {
            if ($module['name'] == $__field['type'])
            {
                switch ($funcType)
                {
                    case 'settings_field':
                        $ret .= $this->fixPluginOptions($setting, $page, $section, $callback, $__field, $module['settings_field']);
                        break;
                    case 'sanitize':
                        $ret .= $this->fixPluginOptions($setting, $page, $section, $callback, $__field, $module['sanitize']);
                        break;
                    case 'callback':
                        $ret .= $this->fixPluginOptions($setting, $page, $section, $callback, $__field, $module['callback']);
                        break;
                    case 'admin_footer':
                        if (isset($module['admin_footer']))
                        {
                            $ret .= $this->fixPluginOptions($setting, $page, $section, $callback, $__field, $module['admin_footer']);
                        }
                        break;
                    case 'admin_enqueue_scripts':
                        if (isset($module['admin_enqueue_scripts']))
                        {
                            $ret .= $this->fixPluginOptions($setting, $page, $section, $callback, $__field, $module['admin_enqueue_scripts']);
                        }
                        break;
                }
            }
        }
        return $ret;
    }

    /**
     * Modules::fixPluginOptions()
     * 
     * @param string $callback
     * @param string $field
     * @param string $string
     * @return
     */
    private function fixPluginOptions($setting, $page, $section, $callback, $field, $string)
    {
        $new_string = $string;
        $new_string = str_replace('{{NAME}}', $this->string->toFileName($this->short_name . '-' . $field['name']), $new_string);
        $new_string = str_replace('{{ID}}', $this->string->toFileName($this->short_name . '-' . $field['name']), $new_string);
        $new_string = str_replace('{{VAR}}', $this->string->toVar($this->short_name . '-' . $field['name']), $new_string);
        $new_string = str_replace('{{LABEL}}', $field['label'], $new_string);
        $new_string = str_replace('{{OPTIONS}}', $field['options'], $new_string);
        $new_string = str_replace('{{INFO}}', $field['info'], $new_string);
        $new_string = str_replace('{{TEXT-DOMAIN}}', $this->textdomain, $new_string);
        $new_string = str_replace('{{TEXTDOMAIN}}', $this->textdomain, $new_string);
        $new_string = str_replace('{{PLACEHOLDER}}', $field['options'], $new_string);
        $new_string = str_replace('{{DEFAULT}}', $field['default'], $new_string);
        $new_string = str_replace('{{SHORT-NAME}}', $this->short_name, $new_string);
        $new_string = str_replace('{{SHORTNAME}}', strtolower($this->short_name), $new_string);
        $new_string = str_replace('{{CALLBACK}}', $callback, $new_string);
        $new_string = str_replace('{{PAGE}}', $page, $new_string);
        $new_string = str_replace('{{SECTION}}', $section, $new_string);
        $new_string = str_replace('{{SETTING}}', $setting, $new_string);
        return $new_string;
    }


    /**
     * Modules::fixWidgetOptions()
     * 
     * @param mixed $field
     * @param mixed $string
     * @return void
     */
    private function fixWidgetOptions($field, $string)
    {
        $new_string = $string;
        $new_string = str_replace('{{NAME}}', $this->string->toFileName($field['name']), $new_string);
        $new_string = str_replace('{{ID}}', $this->string->toFileName($field['name']), $new_string);
        $new_string = str_replace('{{VAR}}', $this->string->toVar($field['name']), $new_string);
        $new_string = str_replace('{{LABEL}}', $field['label'], $new_string);
        $new_string = str_replace('{{OPTIONS}}', $field['options'], $new_string);
        $new_string = str_replace('{{INFO}}', $field['info'], $new_string);
        $new_string = str_replace('{{TEXT-DOMAIN}}', $this->textdomain, $new_string);
        $new_string = str_replace('{{TEXTDOMAIN}}', $this->textdomain, $new_string);
        $new_string = str_replace('{{PLACEHOLDER}}', $field['options'], $new_string);
        $new_string = str_replace('{{DEFAULT}}', $field['default'], $new_string);
        $new_string = str_replace('{{SHORT-NAME}}', $this->short_name, $new_string);
        $new_string = str_replace('{{SHORTNAME}}', strtolower($this->short_name), $new_string);
        return $new_string;
    }


}

?>